/*
 * $Id: dcf77.h,v 1.3 2008/05/08 09:51:28 fvecoven Exp $
 *
 * Copyright (C) 2008 Frederic Vecoven
 *
 * This file is part of NixieClock
 *
 * NixieClock is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * NixieClock is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _DCF77_H
#define	_DCF77_H

#include "NixieClock.h"
#include "time.h"

/*
 * Lengths of the various pulses, in multiple of 100us
 *
 * We check if the measured time is greather than this value, so allow
 * some margin.
 */
#define	DCF_2_S		15000
#define	DCF_0_2_S	1500
#define	DCF_0_1_S	750


typedef union {
	unsigned char value;
	struct {
		unsigned full :1;	// true when a full frame is received
		unsigned parity :1;
		unsigned synced :1;	// true when in sync with the
					// dcf signal
	};
} dcf_flags_t;


/* Macro to tell when dcf77 has received a full frame and set
 * the time.
 */
#define	DCF77_FINISHED	(!flags.do_dcf)


/* prototypes */
void dcf77_enable(char);
void dcf77_fsm(void);


/* variables */
extern volatile time_t dcf_time;
extern volatile date_t dcf_date;



#endif
