/*
 * $Id: ds1307.h,v 1.5 2008/05/08 09:51:28 fvecoven Exp $
 *
 * Copyright (C) 2008 Frederic Vecoven
 *
 * This file is part of NixieClock
 *
 * NixieClock is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * NixieClock is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _DS1307_H
#define	_DS1307_H

#include "time.h"

#define	DS1307_SLA	0b11010000

#define	DS1307_CONFIG	0x11	// clock output enable, 4096Hz

#define	DS1307_SEC	0
#define	DS1307_MIN	1
#define	DS1307_HOUR	2
#define	DS1307_WEEKDAY	3
#define	DS1307_DAY	4
#define	DS1307_MONTH	5
#define	DS1307_YEAR	6
#define	DS1307_CONTROL	7

#define	DS1307_MAGIC_LOC	8
#define	DS1307_MAGIC		'I'

/* prototypes */
int ds1307_read(unsigned char);
signed char ds1307_write(unsigned char, unsigned char);
signed char ds1307_init(void);
signed char ds1307_get_time(volatile time_t *);
signed char ds1307_set_time(volatile time_t *);
signed char ds1307_get_date(volatile date_t *);
signed char ds1307_set_date(volatile date_t *);
signed char ds1307_save_tube_time(void);
signed char ds1307_restore_tube_time(void);


#endif
