/*
 * $Id: editor.h,v 1.8 2008/05/08 09:51:28 fvecoven Exp $
 *
 * Copyright (C) 2008 Frederic Vecoven
 *
 * This file is part of NixieClock
 *
 * NixieClock is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * NixieClock is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _EDITOR_H
#define	_EDITOR_H

/* timeout (in sec) before editor mode is exited */
#define	EDITOR_TIMEOUT	45


/* do NOT renumber this. See editor_get() in editor.c */
#define	TYPE_1_DIGIT	0	// NN -- -X
#define	TYPE_2_DIGIT	1	// NN -- XX
#define	TYPE_3_DIGIT	2	// NN -X XX
#define	TYPE_4_DIGIT	3	// NN XX XX
#define	TYPE_5_DIGIT	4	// -X XX XX
#define	TYPE_6_DIGIT	5	// XX XX XX
#define	TYPE_4_TIME	6  	// 00:00 -> 23:59
#define	TYPE_6_TIME	7	// 00:00:00 -> 23:59:59
#define	TYPE_6_DATE	8	// DD.MM.YY


typedef struct {
	char type;
	unsigned int x_min;
	unsigned int x_max;
	char editable;
	void (*f_get)(void);
	void (*f_set)(void);
	char (*f_valid)(void);
} menu_t;


#ifndef NULL
#define	NULL ((void *)0)
#endif


/* prototypes */
void editor_init(void);
void editor_timeout(void);
void editor_get(void);
void editor_refresh(void);
void editor_enter(void);
void editor_num(char, char);
void editor_up_down(signed char);
void editor_adjust_digit(signed char, char);
void editor_adjust_menu(signed char);
void editor_inc_digit(signed char);


/* variables */
extern unsigned char ed_timeout;


#endif
