/*
 * $Id: nec.h,v 1.2 2008/05/08 09:51:28 fvecoven Exp $
 *
 * Copyright (C) 2008 Frederic Vecoven
 *
 * This file is part of NixieClock
 *
 * NixieClock is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * NixieClock is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _NEC_H
#define	_NEC_H

/*
 * NEC IR protocol
 *
 * http://www.sbprojects.com/knowledge/ir/nec.htm
 */

/* multiple of 100uS */
#define	NEC_TIMEOUT	100
#define	NEC_START	75	// pulse is 9ms
#define	NEC_START2	38
#define	NEC_PULSE_MIN	3
#define	NEC_PULSE_MAX	7
#define	NEC_0		14
#define	NEC_1		25

#define	NEC_ADDRESS	0x3F

#define	KEY_1		0x5F
#define	KEY_2		0x9F
#define	KEY_3		0x1F
#define	KEY_4		0x6F
#define	KEY_5		0xAF
#define	KEY_6		0x2F
#define	KEY_7		0x4F
#define	KEY_8		0x8F
#define	KEY_9		0x0F
#define	KEY_0		0xB7
#define	KEY_DOT		0x7D
#define	KEY_ENTER	0x37
#define	KEY_PIP		0xAD
#define	KEY_SNAPSHOT	0xED
#define	KEY_TIMESHIFT	0x5D
#define	KEY_REC		0x1D
#define	KEY_VOL_UP	0xDF
#define	KEY_VOL_DOWN	0xEF
#define	KEY_CH_UP	0xCF
#define	KEY_CH_DOWN	0xF7
#define	KEY_MUTE	0xD7
#define	KEY_RECALL	0x77
#define	KEY_DISPLAY	0x97
#define	KEY_BOSS	0x6D
#define	KEY_FULL	0x3F
#define	KEY_CH_SURF	0x75
#define	KEY_TV_FM	0xBF
#define	KEY_POWER	0xFF


typedef union {
	struct {
		unsigned first :1;
		unsigned second :1;
		unsigned third :1;
		unsigned in_pulse :1;
		unsigned in_0_or_1 :1;
	};
	unsigned char value;
} nec_t;

/* prototypes */
void nec_enable(void);
void nec_reset(void);
void handle_nec_interrupt(void);


/* extern variables */
extern volatile unsigned char IR_count;
extern volatile unsigned char command;



#endif
