/*
 * $Id: sw_i2c.h,v 1.4 2008/05/08 09:51:29 fvecoven Exp $
 *
 * Copyright (C) 2008 Frederic Vecoven
 *
 * This file is part of NixieClock
 *
 * NixieClock is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * NixieClock is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _SW_I2C_H
#define	_SW_I2C_H

/* User defined pins */
#define	I2C_SDA_PIN	PORTCbits.RC4
#define	I2C_SDA_LAT	LATCbits.LATC4
#define	I2C_SDA_TRIS	TRISCbits.TRISC4

#define	I2C_SCL_PIN	PORTCbits.RC5
#define	I2C_SCL_LAT	LATCbits.LATC5
#define	I2C_SCL_TRIS	TRISCbits.TRISC5


/* macros */
#define	DATA_LOW	I2C_SDA_TRIS = 0;
#define	DATA_HI		I2C_SDA_TRIS = 1;
#define	DATA_LAT	I2C_SDA_LAT
#define	DATA_PIN	I2C_SDA_PIN

#define	CLOCK_LOW	I2C_SCL_TRIS = 0;
#define	CLOCK_HI	I2C_SCL_TRIS = 1;
#define	SCLK_LAT	I2C_SCL_LAT
#define	SCLK_PIN	I2C_SCL_PIN

/* prototypes */
void i2c_init(void);
void i2c_start(void);
void i2c_stop(void);
void i2c_restart(void);
signed char i2c_ack(void);
signed char i2c_clock_test(void);
unsigned int i2c_read(void);
unsigned int i2c_getc(void);
signed char i2c_gets(unsigned char *, unsigned char);
signed char i2c_write(unsigned char);
signed char i2c_putc(unsigned char);
signed char i2c_puts(unsigned char *);


#endif
