/*
 * $Id: time.h,v 1.8 2008/05/08 09:51:29 fvecoven Exp $
 *
 * Copyright (C) 2008 Frederic Vecoven
 *
 * This file is part of NixieClock
 *
 * NixieClock is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * NixieClock is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _TIME_H
#define	_TIME_H


#define	MIN_OVERLAP	0x1
#define	HOUR_OVERLAP	0x2
#define	DAY_OVERLAP	0x4


/* time structure */
typedef struct {
	unsigned char hour;
	unsigned char min;
	unsigned char sec;
} time_t;

/* date structure */
typedef struct {
	unsigned char year;
	unsigned char month;
	unsigned char day;
	unsigned char weekday;
} date_t;

/* tube "on" time structure */
typedef struct {
	unsigned int day;
	char hour;
	char min;
	char sec;
} tube_time_t;

/* hh:mm structure */
typedef struct {
	char hour;
	char min;
} hm_t;


/* prototypes */
signed char set_time(volatile time_t *);
signed char set_date(volatile date_t *);
void time_inc(void);
signed char increment_time(volatile time_t *);
void time_refresh(void);
void start_alarm(void);
void stop_alarm(void);
void minute_work(void);
void hour_work(void);
char tube_save_check(void);


/* variables */
extern volatile time_t time;
extern volatile date_t date;
extern volatile tube_time_t tube_time;
extern hm_t tube_on;
extern hm_t tube_off;
extern hm_t alarm;
extern volatile unsigned char tick;
extern volatile unsigned char beep_duration;


#endif
