/*
 * $Id: tubes.h,v 1.5 2008/05/08 09:51:29 fvecoven Exp $
 *
 * Copyright (C) 2008 Frederic Vecoven
 *
 * This file is part of NixieClock
 *
 * NixieClock is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * NixieClock is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _TUBES_H
#define	_TUBES_H

#include "time.h"

/* support for decimal point */
#define	USE_DP	1

#define	T_1	0x01
#define	T_2	0x02
#define	T_BOTH	0x03


/* prototypes */
void tubes_enable(char);
void tubes_refresh(void);
void tubes_brightness(unsigned char);
void tubes_adjust_brightness(signed char);
void tubes_set_pair(char, char, unsigned char, char);
void tubes_set_one(char, char, unsigned char);
void tubes_prevention_enable(void);
void tubes_prevention_refresh(void);


/* variables */
extern volatile unsigned char tubes_raw[3];
extern volatile unsigned char tubes_2_raw[3];
extern volatile unsigned char brightness;
extern volatile unsigned char brightness_refresh;
extern volatile unsigned char fade_threshold;
extern volatile unsigned char t_prevent;
extern volatile unsigned int t_time;
extern volatile unsigned char t_time_reload;
extern volatile unsigned char t_current;
extern volatile hm_t t_when;

#if USE_DP
extern volatile unsigned char tubes_dp;
#endif


#endif
